/*******************************************************************************
 * FoxProfileSettings generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxProfileSettings extends OnlineProfileSettings
    native;

const PSI_AutoReload = 33;
const PSI_AutoSwitch = 34;
const ID_GamepadSensitivity = 35;
const ID_ControlSchemeIndex = 38;
const ID_AvatarIndex = 39;
const ID_SwapSticks = 40;
const ID_Subversion = 48;
const ID_SecretCodeReserved0 = 60;
const ID_SecretCodeReserved1 = 61;
const ID_LoadoutTutorialSeen = 63;
const ID_DefaultLoadoutPVEID = 64;
const ID_DefaultLoadoutID = 65;
const ID_LoadoutsMigrated = 66;
const ID_LoadoutIndex = 67;
const ID_GameTime = 68;
const ID_SelectedDevice = 69;
const ID_GameTypeFilter = 70;
const ID_PurchaseSettings = 80;
const ID_TwitterUserName = 81;
const ID_TwitterTokenKey = 82;
const ID_TwitterTokenSecret = 83;
const ID_TwitterAutos = 84;
const ID_AccountMigratePromptSeen = 85;
const ID_AccountMigrateCompleteSeen = 86;
const ID_ToggleCrouch = 90;
const ID_InvertControls = 91;
const ID_TightAimToggle = 92;
const ID_AimAssist = 93;
const ID_GamepadTightAimSensitivity = 94;
const ID_SprintToggle = 95;
const ID_HRVToggle = 96;
const ID_ADS_Fix = 97;
const ID_ViewAccelMultipler = 98;
const ID_MouseAcceleration = 99;
const ID_SSDMovies = 100;
const ID_ScoreBoardToggle = 101;
const ID_SmartReticleOpacity = 102;
const ID_NumCrosshairTicks = 103;
const ID_CrosshairRotation = 104;
const ID_CrosshairOpacity = 105;
const ID_CrosshairTickLength = 106;
const ID_CrosshairNeutralColorIndex = 107;
const ID_CrosshairFriendlyColorIndex = 108;
const ID_CrosshairEnemyInRangeColorIndex = 109;
const ID_CrosshairEnemyOutOfRangeColorIndex = 110;
const ID_FOV = 111;
const ID_GoreLevel = 112;
const ID_HiddenHud = 113;
const ID_Notifications = 114;
const ID_StaticCrosshairs = 115;
const ID_DepotPing = 117;
const ID_SpectateThroughDeath = 118;
const ID_EnableSpawnEffects = 119;
const ID_CumulativeScore = 1200;
const ID_NotificationFlags = 1201;
const ID_RecoilReset = 1202;
const ID_FOVInVehicle = 1203;
const ID_Region = 1204;
const ID_Subtitles = 120;
const ID_MusicVolume = 121;
const ID_SFXVolume = 122;
const ID_DialogVolume = 123;
const ID_DamageCauseVolume = 129;
const ID_DamageTakeVolume = 130;
const ID_LowStaminaAudio = 131;
const ID_DialogDefault = 132;
const ID_TauntAudio = 133;
const ID_GammaLevel = 150;
const ID_3DMode = 151;
const ID_LetterBox = 152;
const ID_RainEffect = 153;
const ID_ZoomBlur = 154;
const ID_SocialOptOuts = 200;
const ID_FilterChat = 201;
const ID_HangerUnlockSlot0 = 401;
const ID_HangerUnlockSlot1 = 402;
const ID_HangerUnlockSlot2 = 403;
const ID_HangerUnlockSlot3 = 404;
const ID_HangerUnlockSlot4 = 405;
const ID_HangerUnlockSlot5 = 406;
const ID_HangerUnlockSlot6 = 407;
const ID_HangerUnlockSlot7 = 408;
const ID_DLCReserved0 = 500;
const ID_DLCReserved1 = 501;
const ID_DLCReserved2 = 502;
const ID_DLCReserved3 = 503;
const ID_DLCReserved4 = 504;
const ID_DLCReserved5 = 505;
const ID_DLCReserved6 = 506;
const ID_DLCReserved7 = 507;
const ID_DLCReserved8 = 508;
const ID_DLCReserved9 = 509;
const ID_LoadoutReserved0 = 600;
const ID_LoadoutReserved1 = 601;
const ID_LoadoutReserved2 = 602;
const ID_LoadoutReserved3 = 603;
const ID_LoadoutReserved4 = 604;
const ID_LoadoutReserved5 = 605;
const ID_LoadoutReserved6 = 606;
const ID_LoadoutReserved7 = 607;
const ID_LoadoutReserved8 = 608;
const ID_LoadoutReserved9 = 609;
const ID_LoadoutReserved10 = 610;
const ID_LoadoutReserved11 = 611;
const ID_LoadoutReserved12 = 612;
const ID_LoadoutReserved13 = 613;
const ID_LoadoutReserved14 = 614;
const ID_LoadoutReserved15 = 615;
const ID_LoadoutReserved16 = 616;
const ID_LoadoutReserved17 = 617;
const ID_LoadoutReserved18 = 618;
const ID_LoadoutReserved19 = 619;
const ID_LoadoutReserved20 = 620;
const ID_LoadoutReserved21 = 621;
const ID_LoadoutReserved22 = 622;
const ID_LoadoutReserved23 = 623;
const ID_LoadoutReserved24 = 624;
const ID_DepotReserved0 = 650;
const ID_GearReserved0 = 660;
const ID_GearReserved1 = 661;
const ID_GearReserved2 = 662;
const ID_TauntReserved0 = 670;
const ID_TauntReserved1 = 671;
const ID_DialogPackReserved0 = 672;
const ID_ThirdPersonTaunts = 680;
const ID_TutorialEnabled = 700;
const ID_TutorialReserved0 = 701;
const ID_TutorialReserved1 = 702;
const ID_EULAAcceptVersion = 710;
const ID_NewsReadTime0 = 711;
const ID_NewsReadTime1 = 712;
const ID_NewsReadVersion = 713;
const ID_MutatorNotification = 714;
const ID_HudSkin = 716;
const ID_MouseSensitivity = 717;
const ID_MouseTightAimSensitivity = 718;
const ID_CachedPlaylistSearchFilter = 720;
const ID_LoadoutSwapperWithMovementKeys = 721;
const ID_AutoOpenLoadoutManager = 722;
const ID_DeadZoneLeftStick = 1300;
const ID_DeadZoneRightStick = 1301;
const ID_LastSeenDefaultAnnouncementMD5 = 730;
const ID_LastSeenOverrideAnnouncementMD5 = 731;
const LoadoutID_BYTE_UNSET = 255;
const LoadoutID_SHORT_UNSET = 65535;

enum EOnOffOption
{
    OOO_Off,
    OOO_On,
    OOO_Unset,
    OOO_MAX
};

var const array<int> VersionMismatchResetIds;
var const int ProfileSubversion;

static function int UnlockIDToOffset(int UnlockID, int StartRange, int EndRange)
{
    // End:0x47
    if((UnlockID >= StartRange) && UnlockID <= EndRange)
    {
        UnlockID -= StartRange;
    }
    // End:0x56
    else
    {
        UnlockID = -1;
    }
    return UnlockID;
    //return ReturnValue;    
}

static function int OffsetToUnlockID(int OffsetID, int StartRange, int EndRange)
{
    local int RangeLength;

    RangeLength = EndRange - StartRange;
    // End:0x5D
    if((RangeLength > 0) && OffsetID <= RangeLength)
    {
        OffsetID += StartRange;
    }
    // End:0x68
    else
    {
        OffsetID = 0;
    }
    return OffsetID;
    //return ReturnValue;    
}

event SetToDefaults()
{
    local ProfileLoadoutSlot DefaultLoadoutData;
    local ProfileGearInfo DefaultGearData;
    local ProfileDepotInfo DefaultDepotData;
    local ProfileTauntInfo DefaultTauntData;
    local ProfileDialogInfo DefaultDialogData;
    local ProfilePurchaseInfo DefaultPurchaseData;
    local int I;

    super.SetToDefaults();
    I = 0;
    J0x15:
    // End:0x80 [Loop If]
    if(I < 5)
    {
        class'FoxLoadoutInfo'.static.SetWeaponLoadoutToDefaults(DefaultLoadoutData, I);
        SaveProfileLoadoutSlot(I, DefaultLoadoutData);
        ++ I;
        // [Loop Continue]
        goto J0x15;
    }
    class'FoxLoadoutInfo'.static.SetDepotToDefaults(DefaultDepotData);
    SaveDepot(DefaultDepotData);
    class'FoxLoadoutInfo'.static.SetGearToDefaults(DefaultGearData);
    SaveGear(DefaultGearData);
    class'FoxLoadoutInfo'.static.SetTauntsToDefaults(DefaultTauntData);
    SaveTaunts(DefaultTauntData);
    class'FoxLoadoutInfo'.static.SetDialogPacksToDefaults(DefaultDialogData);
    SaveDialogPacks(DefaultDialogData);
    SaveDefaultPurchaseSettings(DefaultPurchaseData);
    I = 0;
    J0x18A:
    // End:0x391 [Loop If]
    if(I < class'FoxUI'.default.CrosshairColors.Length)
    {
        // End:0x22A
        if(class'FoxUI'.default.CrosshairColors[I].Name ~= class'FoxUI'.default.CrosshairDefaultNeutralColor)
        {
            SetSettingValueInt(107, I);
        }
        // End:0x29D
        if(class'FoxUI'.default.CrosshairColors[I].Name ~= class'FoxUI'.default.CrosshairDefaultFriendlyColor)
        {
            SetSettingValueInt(108, I);
        }
        // End:0x310
        if(class'FoxUI'.default.CrosshairColors[I].Name ~= class'FoxUI'.default.CrosshairDefaultEnemyInRangeColor)
        {
            SetSettingValueInt(109, I);
        }
        // End:0x383
        if(class'FoxUI'.default.CrosshairColors[I].Name ~= class'FoxUI'.default.CrosshairDefaultEnemyOutRangeColor)
        {
            SetSettingValueInt(110, I);
        }
        ++ I;
        // [Loop Continue]
        goto J0x18A;
    }
    //return;    
}

event bool IsMouseYInverted()
{
    local int InversionVal;
    local bool bEnabled;

    // End:0x6A
    if((GetProfileSettingValueId(91, InversionVal)) && InversionVal != 2)
    {
        switch(InversionVal)
        {
            // End:0x51
            case 0:
                bEnabled = false;
                // End:0x67
                break;
            // End:0x64
            case 1:
                bEnabled = true;
                // End:0x67
                break;
            // End:0xFFFF
            default:
                // End:0xC2
                break;
            }
    }
    // End:0xC2
    if(GetProfileSettingValueId(2, InversionVal))
    {
        switch(InversionVal)
        {
            // End:0xA9
            case 0:
                bEnabled = false;
                // End:0xBF
                break;
            // End:0xBC
            case 1:
                bEnabled = true;
                // End:0xBF
                break;
            // End:0xFFFF
            default:
                // End:0xC2
                break;
            }
    }
    return bEnabled;
    //return ReturnValue;    
}

event bool IsTightAimToggleOn()
{
    return IsSettingEnabled(92);
    //return ReturnValue;    
}

event bool IsSubtitlesEnabled()
{
    return IsSettingEnabled(120);
    //return ReturnValue;    
}

event bool Is3DModeEnabled()
{
    return IsSettingEnabled(151);
    //return ReturnValue;    
}

event bool IsSettingEnabled(int SettingId)
{
    local bool bEnabled;
    local int SettingVal;

    // End:0x5C
    if(GetProfileSettingValueId(SettingId, SettingVal))
    {
        switch(SettingVal)
        {
            // End:0x46
            case 0:
                bEnabled = false;
                // End:0x5C
                break;
            // End:0x59
            case 1:
                bEnabled = true;
                // End:0x5C
                break;
            // End:0xFFFF
            default:
            }
            return bEnabled;
            //return ReturnValue;            
}

event int GetSettingInt(int SettingId)
{
    local int Value;

    GetProfileSettingValueInt(SettingId, Value);
    return Value;
    //return ReturnValue;    
}

event bool IsDefaultSettingEnabled(int SettingId)
{
    local bool bEnabled;
    local int SettingVal, ListIndex;

    // End:0x64
    if(GetProfileSettingDefaultId(SettingId, SettingVal, ListIndex))
    {
        switch(SettingVal)
        {
            // End:0x4E
            case 0:
                bEnabled = false;
                // End:0x64
                break;
            // End:0x61
            case 1:
                bEnabled = true;
                // End:0x64
                break;
            // End:0xFFFF
            default:
            }
            return bEnabled;
            //return ReturnValue;            
}

event int GetDefaultInt(int SettingId)
{
    local int Value;

    GetProfileSettingDefaultInt(SettingId, Value);
    return Value;
    //return ReturnValue;    
}

event int GetMusicVolume()
{
    return GetSettingInt(121);
    //return ReturnValue;    
}

event int GetSFXVolume()
{
    return GetSettingInt(122);
    //return ReturnValue;    
}

event int GetDialogVolume()
{
    return GetSettingInt(123);
    //return ReturnValue;    
}

event float GetGammaValue(optional bool bRawValue)
{
    local int GammaSettingInt;
    local float GammaSetting;

    GetProfileSettingValueInt(150, GammaSettingInt);
    // End:0x2F
    if(bRawValue)
    {
        return float(GammaSettingInt);
    }
    GammaSetting = (float(GammaSettingInt) / 50.0) + float(1);
    // End:0x87
    if((GammaSetting < 1.0) || GammaSetting > 3.0)
    {
        GammaSetting = 2.20;
    }
    return GammaSetting;
    //return ReturnValue;    
}

event float GetInGameTimePlayed()
{
    local int Value;

    // End:0x1A
    if(!GetProfileSettingValueInt(68, Value))
    {
    }
    return float(Value);
    //return ReturnValue;    
}

event float GetGamepadSensitivityValue()
{
    local int Value;

    GetProfileSettingValueInt(35, Value);
    return float(Value) / 1000.0;
    //return ReturnValue;    
}

event float GetMouseSensitivityValue()
{
    local int Value;

    GetProfileSettingValueInt(717, Value);
    return float(Value) / 1000.0;
    //return ReturnValue;    
}

event float GetGamepadTightAimSensitivityValue()
{
    local int Value;

    GetProfileSettingValueInt(94, Value);
    return float(Value) / 1000.0;
    //return ReturnValue;    
}

event float GetMouseTightAimSensitivityValue()
{
    local int Value;

    GetProfileSettingValueInt(718, Value);
    return float(Value) / 1000.0;
    //return ReturnValue;    
}

event float GetDeadZoneLeftStick()
{
    local int Value;

    GetProfileSettingValueInt(1300, Value);
    return float(Value) / 1000.0;
    //return ReturnValue;    
}

event float GetDeadZoneRightStick()
{
    local int Value;

    GetProfileSettingValueInt(1301, Value);
    return float(Value) / 1000.0;
    //return ReturnValue;    
}

event float GetDefaultGamepadSensitivityValue()
{
    local int Value;

    Value = GetDefaultInt(35);
    return float(Value) / 1000.0;
    //return ReturnValue;    
}

event float GetDefaultMouseSensitivityValue()
{
    local int Value;

    Value = GetDefaultInt(717);
    return float(Value) / 1000.0;
    //return ReturnValue;    
}

event float GetDefaultGamepadTightAimSensitivityValue()
{
    local int Value;

    Value = GetDefaultInt(94);
    return float(Value) / 1000.0;
    //return ReturnValue;    
}

event float GetDefaultMouseTightAimSensitivityValue()
{
    local int Value;

    Value = GetDefaultInt(718);
    return float(Value) / 1000.0;
    //return ReturnValue;    
}

event float GetDefaultDeadZoneLeftStick()
{
    local int Value;

    Value = GetDefaultInt(1300);
    return float(Value) / 1000.0;
    //return ReturnValue;    
}

event float GetDefaultDeadZoneRightStick()
{
    local int Value;

    Value = GetDefaultInt(1301);
    return float(Value) / 1000.0;
    //return ReturnValue;    
}

event bool IsAutoReloadToggled()
{
    return IsSettingEnabled(33);
    //return ReturnValue;    
}

event bool IsAutoSwitchToggled()
{
    return IsSettingEnabled(34);
    //return ReturnValue;    
}

event bool IsAimAssistToggled()
{
    return IsSettingEnabled(93);
    //return ReturnValue;    
}

event int GetControlSchemeIndex()
{
    return GetSettingInt(38);
    //return ReturnValue;    
}

event int GetAvatarIndex()
{
    return GetSettingInt(39);
    //return ReturnValue;    
}

// Export UFoxProfileSettings::execIsHangerUnlocked(FFrame&, void* const)
native function bool IsHangerUnlocked(int HangerUnlockID);

event bool RetrieveTaunts(out ProfileTauntInfo TauntData)
{
    local int TauntData0, TauntData1;

    GetProfileSettingValueInt(670, TauntData0);
    GetProfileSettingValueInt(671, TauntData1);
    TauntData.TauntID0 = TauntOffsetToUnlockID(TauntData0 & 255);
    TauntData0 = TauntData0 >> 8;
    TauntData.TauntID1 = TauntOffsetToUnlockID(TauntData0 & 255);
    TauntData0 = TauntData0 >> 8;
    TauntData.TauntID2 = TauntOffsetToUnlockID(TauntData0 & 255);
    TauntData0 = TauntData0 >> 8;
    TauntData.TauntID3 = TauntOffsetToUnlockID(TauntData0 & 255);
    TauntData.TauntID4 = TauntOffsetToUnlockID(TauntData1 & 255);
    TauntData1 = TauntData1 >> 8;
    TauntData.TauntID5 = TauntOffsetToUnlockID(TauntData1 & 255);
    TauntData1 = TauntData1 >> 8;
    TauntData.TauntID6 = TauntOffsetToUnlockID(TauntData1 & 255);
    TauntData1 = TauntData1 >> 8;
    TauntData.TauntID7 = TauntOffsetToUnlockID(TauntData1 & 255);
    return true;
    //return ReturnValue;    
}

static function int TauntUnlockIDToOffset(int UnlockID)
{
    return UnlockIDToOffset(UnlockID, 300, 499);
    //return ReturnValue;    
}

static function int TauntOffsetToUnlockID(int OffsetID)
{
    return OffsetToUnlockID(OffsetID, 300, 499);
    //return ReturnValue;    
}

event bool RetrieveDialogPacks(out ProfileDialogInfo DialogData)
{
    local int DialogData0;

    GetProfileSettingValueInt(672, DialogData0);
    DialogData.DialogAnnouncerID = OffsetToUnlockID(DialogData0 & 255, 63000, 63049);
    DialogData0 = DialogData0 >> 8;
    DialogData.DialogPlayerID = OffsetToUnlockID(DialogData0 & 255, 63050, 63099);
    return true;
    //return ReturnValue;    
}

// Export UFoxProfileSettings::execDecodeEmblem(FFrame&, void* const)
native static function bool DecodeEmblem(QWord InData, out ProfileEmblemInfo EmblemData);

static function QWord EncodeEmblem(const ProfileEmblemInfo EmblemData)
{
    local int DataA, DataB;

    DataA = DataA | (((UnlockIDToOffset(EmblemData.ToPlayer.IconID, 64000, 64639)) & 1023) << 0);
    DataA = DataA | (((UnlockIDToOffset(EmblemData.MiddleLayer.IconID, 64640, 64739)) & 127) << 10);
    DataA = DataA | (((UnlockIDToOffset(EmblemData.BottomLayer.IconID, 64740, 64749)) & 15) << 17);
    DataB = DataB | (((UnlockIDToOffset(EmblemData.ToPlayer.ColorID, 64750, 64999)) & 255) << 0);
    DataB = DataB | (((UnlockIDToOffset(EmblemData.MiddleLayer.ColorID, 64750, 64999)) & 255) << 8);
    DataB = DataB | (((UnlockIDToOffset(EmblemData.BottomLayer.ColorID, 64750, 64999)) & 255) << 16);
    return MakeQWORD(DataA, DataB);
    //return ReturnValue;    
}

// Export UFoxProfileSettings::execMakeQWORD(FFrame&, void* const)
native static function QWord MakeQWORD(int A, int B);

event bool RetrieveGear(out ProfileGearInfo GearData)
{
    local int GearData0, GearData1, GearData2;
    local ProfileEmblemInfo EmblemData;
    local OnlineSubsystem OnlineSub;

    GetProfileSettingValueInt(660, GearData0);
    GetProfileSettingValueInt(661, GearData1);
    GetProfileSettingValueInt(662, GearData2);
    GearData.Gear_R2ID = byte(GearData0 & 63);
    GearData0 = GearData0 >> 6;
    GearData.Gear_R1ID = byte(GearData0 & 63);
    GearData0 = GearData0 >> 6;
    GearData.HelmetID = byte(GearData0 & 255);
    GearData0 = GearData0 >> 8;
    GearData.LowerBodyID = byte(GearData0 & 63);
    GearData0 = GearData0 >> 6;
    GearData.UpperBodyID = byte(GearData0 & 63);
    GearData1 = GearData1 >> 8;
    GearData.ButtPackID = byte(GearData1 & 63);
    GearData1 = GearData1 >> 6;
    GearData.TacticalID = byte(GearData1 & 63);
    GearData1 = GearData1 >> 6;
    GearData.Gear_L2ID = byte(GearData1 & 63);
    GearData1 = GearData1 >> 6;
    GearData.Gear_L1ID = byte(GearData1 & 63);
    GearData2 = GearData2 >> 13;
    GearData.bFemale = bool(GearData2 & 1);
    GearData2 = GearData2 >> 1;
    GearData.BodyCamoID = byte(GearData2 & 511);
    GearData2 = GearData2 >> 9;
    GearData.BadgeID = GearData2 & 511;
    OnlineSub = class'GameEngine'.static.GetOnlineSubsystem();
    // End:0x5A7
    if(((OnlineSub != none) && NotEqual_InterfaceInterface(OnlineSub.StoreInterface, (none))) && DecodeEmblem(OnlineSub.StoreInterface.GetEmblem(), EmblemData))
    {
        GearData.PatchIconID = EmblemData.ToPlayer.IconID;
        GearData.PatchIconColorID = byte(class'FoxUnlockInfo'.static.GetEmblemComponentIndexFromUnlockID(EmblemData.ToPlayer.ColorID));
        GearData.PatchShapeID = byte(class'FoxUnlockInfo'.static.GetEmblemShapeID(EmblemData.MiddleLayer.IconID));
        GearData.PatchShapeColorID = byte(class'FoxUnlockInfo'.static.GetEmblemComponentIndexFromUnlockID(EmblemData.MiddleLayer.ColorID));
    }
    return true;
    //return ReturnValue;    
}

event bool RetrieveDepot(out ProfileDepotInfo DepotInfo)
{
    local int DepotData;

    GetProfileSettingValueInt(650, DepotData);
    DepotData = DepotData >> 2;
    DepotInfo.DepotPresetID4 = byte(DepotData & 63);
    DepotData = DepotData >> 6;
    DepotInfo.DepotPresetID3 = byte(DepotData & 63);
    DepotData = DepotData >> 6;
    DepotInfo.DepotPresetID2 = byte(DepotData & 63);
    DepotData = DepotData >> 6;
    DepotInfo.DepotPresetID1 = byte(DepotData & 63);
    DepotData = DepotData >> 6;
    DepotInfo.DepotPresetID0 = byte(DepotData & 63);
    return true;
    //return ReturnValue;    
}

event bool HasSeenTutorial(int Index)
{
    local int TutorialDataIndex, TutorialData;

    // End:0x95
    if((Index >= 0) && Index < 64)
    {
        TutorialDataIndex = ((Index < 32) ? 701 : 702);
        Index = Index % 32;
        GetProfileSettingValueInt(TutorialDataIndex, TutorialData);
        return (TutorialData & (1 << Index)) != 0;
    }
    return false;
    //return ReturnValue;    
}

event bool RetrieveLoadoutSlot(int SlotIndex, out ProfileLoadoutSlot LoadoutData)
{
    local int ReservedOffset, Data0, Data1, Data2, Data3, Data4;

    // End:0x23
    if((SlotIndex >= 5) || SlotIndex < 0)
    {
        return false;
    }
    ReservedOffset = (5 * SlotIndex) + 600;
    GetProfileSettingValueInt(ReservedOffset, Data0);
    GetProfileSettingValueInt(ReservedOffset + 1, Data1);
    GetProfileSettingValueInt(ReservedOffset + 2, Data2);
    GetProfileSettingValueInt(ReservedOffset + 3, Data3);
    GetProfileSettingValueInt(ReservedOffset + 4, Data4);
    LoadoutData.PrimaryScopeID = byte(Data0 & 63);
    Data0 = Data0 >> 6;
    LoadoutData.PrimaryMagazineID = byte(Data0 & 255);
    Data0 = Data0 >> 8;
    LoadoutData.PrimaryBarrelID = byte(Data0 & 63);
    Data0 = Data0 >> 6;
    LoadoutData.PrimaryMuzzleID = byte(Data0 & 63);
    Data0 = Data0 >> 6;
    LoadoutData.PrimaryWeaponID = byte(Data0 & 63);
    Data1 = Data1 >> 8;
    LoadoutData.SecondaryMagazineID = byte(Data1 & 255);
    Data1 = Data1 >> 8;
    LoadoutData.SecondaryWeaponID = byte(Data1 & 63);
    Data1 = Data1 >> 6;
    LoadoutData.PrimaryGripID = byte(Data1 & 15);
    Data1 = Data1 >> 4;
    LoadoutData.PrimaryStockID = byte(Data1 & 63);
    LoadoutData.SecondaryAmmoID = byte(Data2 & 15);
    Data2 = Data2 >> 4;
    LoadoutData.PrimaryAmmoID = byte(Data2 & 15);
    Data2 = Data2 >> 4;
    LoadoutData.SecondaryStockID = byte(Data2 & 63);
    Data2 = Data2 >> 6;
    LoadoutData.SecondaryScopeID = byte(Data2 & 63);
    Data2 = Data2 >> 6;
    LoadoutData.SecondaryBarrelID = byte(Data2 & 63);
    Data2 = Data2 >> 6;
    LoadoutData.SecondaryMuzzleID = byte(Data2 & 63);
    LoadoutData.PrimaryWeaponCamo = byte(Data3 & 511);
    Data3 = Data3 >> 9;
    LoadoutData.SecondaryWeaponCamo = byte(Data3 & 511);
    Data3 = Data3 >> 9;
    LoadoutData.HangerID = Data3 & 1023;
    Data3 = Data3 >> 10;
    LoadoutData.SecondaryGripID = byte(Data3 & 15);
    LoadoutData.SecondaryAmmoID = byte(Data4 & 255);
    Data4 = Data4 >> 8;
    LoadoutData.PrimaryAmmoID = byte(Data4 & 255);
    Data4 = Data4 >> 8;
    LoadoutData.SecondarySkinID = byte(Data4 & 255);
    Data4 = Data4 >> 8;
    LoadoutData.PrimarySkinID = byte(Data4 & 255);
    return true;
    //return ReturnValue;    
}

function bool IsLoadoutTutorialSeen(int TutorialStep)
{
    local int LoadoutTutorialBitFlags;

    GetProfileSettingValueInt(63, LoadoutTutorialBitFlags);
    // End:0x64
    if((LoadoutTutorialBitFlags >= 0) && LoadoutTutorialBitFlags <= 32)
    {
        LoadoutTutorialBitFlags = (LoadoutTutorialBitFlags >> TutorialStep) & 1;
        return LoadoutTutorialBitFlags == 1;
    }
    return false;
    //return ReturnValue;    
}

event int GetDefaultLoadoutIndex()
{
    local int LoadoutIndex;

    GetProfileSettingValueInt(67, LoadoutIndex);
    return LoadoutIndex;
    //return ReturnValue;    
}

event bool AreLoadoutsMigrated()
{
    local int MigrationValue;

    GetProfileSettingValueInt(66, MigrationValue);
    return ((MigrationValue == 0) ? false : true);
    //return ReturnValue;    
}

function SetDefaultLoadoutID(string LoadoutId)
{
    SetProfileSettingValue(65, LoadoutId);
    //return;    
}

function string GetDefaultLoadoutID()
{
    local string OutLoadoutID;

    GetProfileSettingValue(65, OutLoadoutID);
    return OutLoadoutID;
    //return ReturnValue;    
}

function SetDefaultLoadoutPVEID(string LoadoutId)
{
    SetProfileSettingValue(64, LoadoutId);
    //return;    
}

function string GetDefaultLoadoutPVEID()
{
    local string OutLoadoutID;

    GetProfileSettingValue(64, OutLoadoutID);
    return OutLoadoutID;
    //return ReturnValue;    
}

function SetRegionTag(string RegionTag)
{
    SetProfileSettingValue(1204, RegionTag);
    //return;    
}

function string GetRegionTag()
{
    local string OutRegionTag;

    GetProfileSettingValue(1204, OutRegionTag);
    return OutRegionTag;
    //return ReturnValue;    
}

event int GetAcceptedEULAVersion()
{
    local int EULAVersionData;

    GetProfileSettingValueInt(710, EULAVersionData);
    return EULAVersionData;
    //return ReturnValue;    
}

event GetLastNewsReadTime(out FoxDateTime OutDateTime)
{
    local int Date, Time;

    GetProfileSettingValueInt(711, Date);
    GetProfileSettingValueInt(712, Time);
    class'FoxDateTimeHelper'.static.Unpack(Date, Time, OutDateTime);
    //return;    
}

event int GetLastNewsReadVersion()
{
    local int NewsVersionData;

    GetProfileSettingValueInt(713, NewsVersionData);
    return NewsVersionData;
    //return ReturnValue;    
}

simulated function bool CanShowHangerInUI(class<FoxWeaponHanger_Base> HangerClass)
{
    return false;
    //return ReturnValue;    
}

event bool IsCrouchToggle()
{
    return IsSettingEnabled(90);
    //return ReturnValue;    
}

event int GetGameTypeFilter()
{
    local int GameFilterIndex;

    GetProfileSettingValueInt(70, GameFilterIndex);
    return GameFilterIndex;
    //return ReturnValue;    
}

event bool RetrieveDefaultPurchaseSettings(out ProfilePurchaseInfo PurchaseData)
{
    local int PurchaseData0;

    GetProfileSettingValueInt(80, PurchaseData0);
    PurchaseData.Duration = 0;
    PurchaseData0 = PurchaseData0 >> 4;
    PurchaseData.bEquip = bool(PurchaseData0 & 1);
    PurchaseData0 = PurchaseData0 >> 1;
    PurchaseData.Currency = 1;
    return true;
    //return ReturnValue;    
}

event bool CheckProfileVersionMismatch()
{
    local int SavedProfileSubversion, I;

    GetProfileSettingValueInt(48, SavedProfileSubversion);
    // End:0xAE
    if(SavedProfileSubversion != ProfileSubversion)
    {
        SetProfileSettingValueInt(48, ProfileSubversion);
        I = 0;
        J0x4C:
        // End:0xAC [Loop If]
        if(I < VersionMismatchResetIds.Length)
        {
            SetSettingValueInt(VersionMismatchResetIds[I], GetDefaultInt(VersionMismatchResetIds[I]));
            ++ I;
            // [Loop Continue]
            goto J0x4C;
        }
        return false;
    }
    return true;
    //return ReturnValue;    
}

event SetSettingValueInt(int SettingId, int Value)
{
    SetProfileSettingValueInt(SettingId, Value);
    //return;    
}

event SetSettingEnabled(int SettingId, bool bEnabled)
{
    SetProfileSettingValueId(SettingId, ((bEnabled) ? 1 : 0));
    //return;    
}

event SetGammaLevel(float Value)
{
    SetSettingValueInt(150, int(Value));
    //return;    
}

event AddInGameTimePlayed(const float NewTime)
{
    local int Current;
    local bool bResult;

    Current = int(GetInGameTimePlayed());
    Current += FFloor(NewTime);
    bResult = SetProfileSettingValueInt(68, Current);
    // End:0x63
    if(!bResult)
    {
    }
    //return;    
}

event SetGamepadSensitivitySetting(float Value)
{
    SetSettingValueInt(35, int(Value * 1000.0));
    //return;    
}

event SetGamepadTightAimSensitivity(float Value)
{
    SetSettingValueInt(94, int(Value * 1000.0));
    //return;    
}

event SetMouseSensitivitySetting(float Value)
{
    SetSettingValueInt(717, int(Value * 1000.0));
    //return;    
}

event SetMouseTightAimSensitivity(float Value)
{
    SetSettingValueInt(718, int(Value * 1000.0));
    //return;    
}

event SetDeadZoneLeftStick(float Value)
{
    SetSettingValueInt(1300, int(Value * 1000.0));
    //return;    
}

event SetDeadZoneRightStick(float Value)
{
    SetSettingValueInt(1301, int(Value * 1000.0));
    //return;    
}

event SetDialogVolume(int Value)
{
    SetSettingValueInt(123, Value);
    //return;    
}

event SetSFXVolume(int Value)
{
    SetSettingValueInt(122, Value);
    //return;    
}

event SetMusicVolume(int Value)
{
    SetSettingValueInt(121, Value);
    //return;    
}

event SetSubtitlesEnabled(bool bEnabled)
{
    SetSettingEnabled(120, bEnabled);
    //return;    
}

event Set3DModeEnabled(bool bEnabled)
{
    SetSettingEnabled(151, bEnabled);
    //return;    
}

event SetInvertYEnabled(bool bEnabled)
{
    SetSettingEnabled(91, bEnabled);
    //return;    
}

event SetTightAimToggleEnabled(bool bEnabled)
{
    SetSettingEnabled(92, bEnabled);
    //return;    
}

event SetAutoReload(bool bEnabled)
{
    SetSettingEnabled(33, bEnabled);
    //return;    
}

event SetAutoSwitch(bool bEnabled)
{
    SetSettingEnabled(34, bEnabled);
    //return;    
}

event SetAimAssist(bool bEnabled)
{
    SetSettingEnabled(93, bEnabled);
    //return;    
}

event SetControlSchemeIndex(int NewValue)
{
    SetSettingValueInt(38, NewValue);
    //return;    
}

event SetAvatarIndex(int NewValue)
{
    SetSettingValueInt(39, NewValue);
    //return;    
}

event SetToggleCrouch(bool bEnabled)
{
    SetSettingEnabled(90, bEnabled);
    //return;    
}

event SetGameFilterIndex(int NewIndex)
{
    SetSettingValueInt(70, NewIndex);
    //return;    
}

event SaveDefaultPurchaseSettings(ProfilePurchaseInfo NewPurchaseData)
{
    local int PurchaseData0;

    PurchaseData0 = PurchaseData0 | ((NewPurchaseData.Duration & 15) << 0);
    PurchaseData0 = PurchaseData0 | ((int(NewPurchaseData.bEquip) & 1) << 4);
    PurchaseData0 = PurchaseData0 | ((NewPurchaseData.Currency & 1) << 5);
    SetProfileSettingValueInt(80, PurchaseData0);
    //return;    
}

function ClearLoadoutTutorialSeen()
{
    SetProfileSettingValueInt(63, 0);
    //return;    
}

function SetLoadoutTutorialSeen(int TutorialPage)
{
    local int LoadoutTutorialBitFlags;

    // End:0x18
    if(IsLoadoutTutorialSeen(TutorialPage))
    {
        return;
    }
    GetProfileSettingValueInt(63, LoadoutTutorialBitFlags);
    LoadoutTutorialBitFlags = LoadoutTutorialBitFlags | (1 << TutorialPage);
    SetProfileSettingValueInt(63, LoadoutTutorialBitFlags);
    //return;    
}

event SetDefaultLoadoutIndex(int NewLoadoutIndex)
{
    SetSettingValueInt(67, NewLoadoutIndex);
    //return;    
}

event SetLoadoutsMigrated(bool bMigrated)
{
    SetSettingValueInt(66, ((bMigrated) ? 1 : 0));
    //return;    
}

event SetAcceptedEULAVersion(int NewEULAVersion)
{
    SetSettingValueInt(710, NewEULAVersion);
    //return;    
}

event SetLastNewsReadTime(const FoxDateTime InDateTime)
{
    local int Date, Time;

    class'FoxDateTimeHelper'.static.Pack(InDateTime, Date, Time);
    SetProfileSettingValueInt(711, Date);
    SetProfileSettingValueInt(712, Time);
    //return;    
}

event SetLastNewsReadVersion(const int InReadVersion)
{
    SetProfileSettingValueInt(713, InReadVersion);
    //return;    
}

event SetLastNewsReadVersionToCurrent()
{
    //return;    
}

event SaveProfileLoadoutSlot(int SlotIndex, ProfileLoadoutSlot LoadoutData)
{
    local int ReservedOffset, Data0, Data1, Data2, Data3, Data4;

    // End:0x23
    if((SlotIndex >= 5) || SlotIndex < 0)
    {
        return;
    }
    ReservedOffset = (5 * SlotIndex) + 600;
    Data0 = (LoadoutData.PrimaryWeaponID & 63) << 26;
    Data0 = Data0 | ((LoadoutData.PrimaryMuzzleID & 63) << 20);
    Data0 = Data0 | ((LoadoutData.PrimaryBarrelID & 63) << 14);
    Data0 = Data0 | ((LoadoutData.PrimaryMagazineID & 255) << 6);
    Data0 = Data0 | (LoadoutData.PrimaryScopeID & 63);
    Data1 = (LoadoutData.PrimaryStockID & 63) << 26;
    Data1 = Data1 | ((LoadoutData.PrimaryGripID & 15) << 22);
    Data1 = Data1 | ((LoadoutData.SecondaryWeaponID & 63) << 16);
    Data1 = Data1 | ((LoadoutData.SecondaryMagazineID & 255) << 8);
    Data2 = (LoadoutData.SecondaryMuzzleID & 63) << 26;
    Data2 = Data2 | ((LoadoutData.SecondaryBarrelID & 63) << 20);
    Data2 = Data2 | ((LoadoutData.SecondaryScopeID & 63) << 14);
    Data2 = Data2 | ((LoadoutData.SecondaryStockID & 63) << 8);
    Data2 = Data2 | ((LoadoutData.PrimaryAmmoID & 15) << 4);
    Data2 = Data2 | (LoadoutData.SecondaryAmmoID & 15);
    Data3 = (LoadoutData.SecondaryGripID & 15) << 28;
    Data3 = Data3 | ((LoadoutData.HangerID & 1023) << 18);
    Data3 = Data3 | ((LoadoutData.SecondaryWeaponCamo & 255) << 9);
    Data3 = Data3 | (LoadoutData.PrimaryWeaponCamo & 255);
    Data4 = (LoadoutData.PrimarySkinID & 255) << 24;
    Data4 = Data4 | ((LoadoutData.SecondarySkinID & 255) << 16);
    Data4 = Data4 | ((LoadoutData.PrimaryAmmoID & 255) << 8);
    Data4 = Data4 | (LoadoutData.SecondaryAmmoID & 255);
    SetProfileSettingValueInt(ReservedOffset, Data0);
    SetProfileSettingValueInt(ReservedOffset + 1, Data1);
    SetProfileSettingValueInt(ReservedOffset + 2, Data2);
    SetProfileSettingValueInt(ReservedOffset + 3, Data3);
    SetProfileSettingValueInt(ReservedOffset + 4, Data4);
    //return;    
}

event bool SaveTaunts(ProfileTauntInfo TauntData)
{
    local int TauntData0, TauntData1;

    TauntData0 = TauntData0 | (((TauntUnlockIDToOffset(TauntData.TauntID0)) & 255) << 0);
    TauntData0 = TauntData0 | (((TauntUnlockIDToOffset(TauntData.TauntID1)) & 255) << 8);
    TauntData0 = TauntData0 | (((TauntUnlockIDToOffset(TauntData.TauntID2)) & 255) << 16);
    TauntData0 = TauntData0 | (((TauntUnlockIDToOffset(TauntData.TauntID3)) & 255) << 24);
    TauntData1 = TauntData1 | (((TauntUnlockIDToOffset(TauntData.TauntID4)) & 255) << 0);
    TauntData1 = TauntData1 | (((TauntUnlockIDToOffset(TauntData.TauntID5)) & 255) << 8);
    TauntData1 = TauntData1 | (((TauntUnlockIDToOffset(TauntData.TauntID6)) & 255) << 16);
    TauntData1 = TauntData1 | (((TauntUnlockIDToOffset(TauntData.TauntID7)) & 255) << 24);
    SetProfileSettingValueInt(670, TauntData0);
    SetProfileSettingValueInt(671, TauntData1);
    return true;
    //return ReturnValue;    
}

event bool SaveDialogPacks(ProfileDialogInfo DialogData)
{
    local int DialogData0;

    DialogData0 = DialogData0 | (((UnlockIDToOffset(DialogData.DialogAnnouncerID, 63000, 63049)) & 255) << 0);
    DialogData0 = DialogData0 | (((UnlockIDToOffset(DialogData.DialogPlayerID, 63050, 63099)) & 255) << 8);
    SetProfileSettingValueInt(672, DialogData0);
    return true;
    //return ReturnValue;    
}

event SaveGear(ProfileGearInfo LoadoutData)
{
    local int GearData0, GearData1, GearData2;

    GearData0 = (LoadoutData.UpperBodyID & 63) << 26;
    GearData0 = GearData0 | ((LoadoutData.LowerBodyID & 63) << 20);
    GearData0 = GearData0 | ((LoadoutData.HelmetID & 255) << 12);
    GearData0 = GearData0 | ((LoadoutData.Gear_R1ID & 63) << 6);
    GearData0 = GearData0 | (LoadoutData.Gear_R2ID & 63);
    GearData1 = (LoadoutData.Gear_L1ID & 63) << 26;
    GearData1 = GearData1 | ((LoadoutData.Gear_L2ID & 63) << 20);
    GearData1 = GearData1 | ((LoadoutData.TacticalID & 63) << 14);
    GearData1 = GearData1 | ((LoadoutData.ButtPackID & 63) << 8);
    GearData2 = (LoadoutData.BadgeID & 511) << 23;
    GearData2 = GearData2 | ((LoadoutData.BodyCamoID & 255) << 14);
    GearData2 = GearData2 | ((int(LoadoutData.bFemale) & 1) << 13);
    SetProfileSettingValueInt(660, GearData0);
    SetProfileSettingValueInt(661, GearData1);
    SetProfileSettingValueInt(662, GearData2);
    //return;    
}

event SaveDepot(ProfileDepotInfo LoadoutData)
{
    local int DepotData;

    DepotData = (LoadoutData.DepotPresetID0 & 63) << 26;
    DepotData = DepotData | ((LoadoutData.DepotPresetID1 & 63) << 20);
    DepotData = DepotData | ((LoadoutData.DepotPresetID2 & 63) << 14);
    DepotData = DepotData | ((LoadoutData.DepotPresetID3 & 63) << 8);
    DepotData = DepotData | ((LoadoutData.DepotPresetID4 & 63) << 2);
    SetProfileSettingValueInt(650, DepotData);
    //return;    
}

function UnlockHanger(int HangerUnlockID)
{
    local int UnlockSlot, UnlockBit, SavedSlotValue, ActualUnlockSlot;

    // End:0x23
    if((HangerUnlockID >= 100) || HangerUnlockID < 0)
    {
        return;
    }
    UnlockSlot = HangerUnlockID >> 5;
    ActualUnlockSlot = 401 + UnlockSlot;
    UnlockBit = 1 << (HangerUnlockID - (UnlockSlot << 5));
    GetProfileSettingValueInt(ActualUnlockSlot, SavedSlotValue);
    SavedSlotValue = SavedSlotValue | UnlockBit;
    SetProfileSettingValueInt(ActualUnlockSlot, SavedSlotValue);
    //return;    
}

event ResetTutorialHistory()
{
    SetProfileSettingValueInt(701, 0);
    SetProfileSettingValueInt(702, 0);
    //return;    
}

event SetTutorialAsSeen(int Index)
{
    local int TutorialDataIndex, TutorialData;

    // End:0xB7
    if((Index >= 0) && Index < 64)
    {
        TutorialDataIndex = ((Index < 32) ? 701 : 702);
        Index = Index % 32;
        GetProfileSettingValueInt(TutorialDataIndex, TutorialData);
        TutorialData = TutorialData | (1 << Index);
        SetProfileSettingValueInt(TutorialDataIndex, TutorialData);
    }
    //return;    
}

function SetCurrentDeviceID(int InDeviceID)
{
    local int CurrValue;

    GetProfileSettingValueInt(69, CurrValue);
    // End:0x41
    if(CurrValue != InDeviceID)
    {
        SetProfileSettingValueInt(69, InDeviceID);
    }
    //return;    
}

function SetTwitterCredentials(string UserName, string TokenKey, string TokenSecret)
{
    SetProfileSettingValue(81, UserName);
    SetProfileSettingValue(82, TokenKey);
    SetProfileSettingValue(83, TokenSecret);
    //return;    
}

function GetTwitterCredentials(out string UserName, out string TokenKey, out string TokenSecret)
{
    GetProfileSettingValue(81, UserName);
    GetProfileSettingValue(82, TokenKey);
    GetProfileSettingValue(83, TokenSecret);
    //return;    
}

function SetLastSeenDefaultAnnouncementMD5(string MD5)
{
    SetProfileSettingValue(730, MD5);
    //return;    
}

function SetLastSeenOverrideAnnouncementMD5(string MD5)
{
    SetProfileSettingValue(731, MD5);
    //return;    
}

function string GetLastSeenDefaultAnnouncementMD5()
{
    local string OutMD5;

    GetProfileSettingValue(730, OutMD5);
    return OutMD5;
    //return ReturnValue;    
}

function string GetLastSeenOverrideAnnouncementMD5()
{
    local string OutMD5;

    GetProfileSettingValue(731, OutMD5);
    return OutMD5;
    //return ReturnValue;    
}

private final function int GetFlags(int FlagID)
{
    local int Ret;

    GetProfileSettingValueInt(FlagID, Ret);
    return Ret;
    //return ReturnValue;    
}

function bool IsDefualtFlagEnabled(int FlagID, int Index)
{
    local int DefaultFlags;

    DefaultFlags = GetDefaultInt(FlagID);
    return (DefaultFlags & (1 << Index)) > 0;
    //return ReturnValue;    
}

function SetFlags(int FlagID, int Index, bool bEnabled)
{
    local int CurrentFlags, SetFlags;

    CurrentFlags = GetFlags(FlagID);
    SetFlags = 1 << Index;
    CurrentFlags = ((bEnabled) ? CurrentFlags | SetFlags : CurrentFlags & ~SetFlags);
    SetProfileSettingValueInt(FlagID, CurrentFlags);
    //return;    
}

event bool IsFlagEnabled(int FlagID, int Index)
{
    local int CurrentFlags;

    CurrentFlags = GetFlags(FlagID);
    return (CurrentFlags & (1 << Index)) > 0;
    //return ReturnValue;    
}

event bool AreFriendRequestsEnabled()
{
    return !IsFlagEnabled(200, 1);
    //return ReturnValue;    
}

event bool ShouldAppearOffline()
{
    return false;
    //return ReturnValue;    
}

event int GetCachedPlaylistSearchFilter()
{
    local FoxDataStore_Playlists PlaylistDataStore;
    local int Filter;
    local string FilterString;

    PlaylistDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
    Filter = -1;
    // End:0xC8
    if(GetProfileSettingValue(720, FilterString))
    {
        Filter = PlaylistDataStore.TranslatePrefToFilter(FilterString);
        // End:0xC8
        if(Filter >= 0)
        {
            return Filter;
        }
    }
    return -1;
    //return ReturnValue;    
}

event SetCachedPlaylistSearchFilter(int Filter)
{
    local FoxDataStore_Playlists PlaylistDataStore;
    local string NewPrefVal, PrevFilter;

    PlaylistDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
    GetProfileSettingValue(720, PrevFilter);
    NewPrefVal = PlaylistDataStore.TranslateFilterToPref(Filter, PrevFilter);
    // End:0xC4
    if((SetProfileSettingValue(720, NewPrefVal)) == false)
    {
    }
    //return;    
}

defaultproperties
{
    VersionMismatchResetIds(0)=35
    VersionMismatchResetIds(1)=94
    VersionMismatchResetIds(2)=111
    VersionMismatchResetIds(3)=1203
    VersionMismatchResetIds(4)=717
    VersionMismatchResetIds(5)=718
    VersionMismatchResetIds(6)=1300
    VersionMismatchResetIds(7)=1301
    ProfileSubversion=4
    ProfileSettingIds=/* Array type was not detected. */
    DefaultSettings=/* Array type was not detected. */
    VersionNumber=45
    ProfileMappings=/* Array type was not detected. */
}